//---------------------------------------------------------------------------
//
//  Module:   driver.h

#define REGISTER_LEFTINPUT      (0x00)
#define REGISTER_RIGHTINPUT     (0x01)
#define REGISTER_LEFTAUX1       (0x02)
#define REGISTER_RIGHTAUX1      (0x03)
#define REGISTER_LEFTAUX2       (0x04)
#define REGISTER_RIGHTAUX2      (0x05)
#define REGISTER_LEFTOUTPUT     (0x06)
#define REGISTER_RIGHTOUTPUT    (0x07)
#define REGISTER_DATAFORMAT     (0x08)
#define REGISTER_INTERFACE      (0x09)
#define REGISTER_DSP            (0x0a)
#define REGISTER_TEST           (0x0b)
#define REGISTER_MISC           (0x0c)
#define REGISTER_LOOPBACK       (0x0d)
#define REGISTER_UPPERBASE      (0x0e)
#define REGISTER_LOWERBASE      (0x0f)

//
// indices into string table
//
#define MIX_STR_BASE            100

#define SR_ALERT               MIX_STR_BASE + 1
#define SR_ALERT_31            MIX_STR_BASE + 2
#define SR_ALERT_NOPATCH       MIX_STR_BASE + 10
#define SR_ALERT_NORESOURCE    MIX_STR_BASE + 11
#define SR_ALERT_MUTED         MIX_STR_BASE + 12

#define SR_STR_DRIVERWAVEIN    MIX_STR_BASE + 13
#define SR_STR_DRIVERWAVEOUT   MIX_STR_BASE + 14
#define SR_STR_DRIVERMIDIOUT   MIX_STR_BASE + 15
#define SR_STR_DRIVERAUX       MIX_STR_BASE + 16
#define SR_STR_DRIVERMIXER     MIX_STR_BASE + 17
#define SR_STR_VOLUME          MIX_STR_BASE + 18

#define SR_ALERT_BAD               MIX_STR_BASE + 19
#define SR_ALERT_BOARD_ERROR       MIX_STR_BASE + 20
#define SR_ALERT_NO_VXD            MIX_STR_BASE + 21
#define SR_ALERT_WRONG_VXD         MIX_STR_BASE + 22


#define SR_STR_MIXER_SOURCE0_LONG  MIX_STR_BASE + 40
#define SR_STR_MIXER_SOURCE1_LONG  MIX_STR_BASE + 41
#define SR_STR_MIXER_SOURCE2_LONG  MIX_STR_BASE + 42
#define SR_STR_MIXER_SOURCE3_LONG  MIX_STR_BASE + 43
#define SR_STR_MIXER_SOURCE0_SHORT MIX_STR_BASE + 44
#define SR_STR_MIXER_SOURCE1_SHORT MIX_STR_BASE + 45
#define SR_STR_MIXER_SOURCE2_SHORT MIX_STR_BASE + 46
#define SR_STR_MIXER_SOURCE3_SHORT MIX_STR_BASE + 47
#define SR_STR_MIXER_DEST0_LONG    MIX_STR_BASE + 48
#define SR_STR_MIXER_DEST1_LONG    MIX_STR_BASE + 49
#define SR_STR_MIXER_DEST2_LONG    MIX_STR_BASE + 50
#define SR_STR_MIXER_DEST0_SHORT   MIX_STR_BASE + 51
#define SR_STR_MIXER_DEST1_SHORT   MIX_STR_BASE + 52
#define SR_STR_MIXER_DEST2_SHORT   MIX_STR_BASE + 53

#define SR_STR_MIXER_CONTROL0_LONG   MIX_STR_BASE + 54
#define SR_STR_MIXER_CONTROL1_LONG   MIX_STR_BASE + 55
#define SR_STR_MIXER_CONTROL2_LONG   MIX_STR_BASE + 56
#define SR_STR_MIXER_CONTROL3_LONG   MIX_STR_BASE + 57
#define SR_STR_MIXER_CONTROL4_LONG   MIX_STR_BASE + 58
#define SR_STR_MIXER_CONTROL5_LONG   MIX_STR_BASE + 59
#define SR_STR_MIXER_CONTROL6_LONG   MIX_STR_BASE + 60
#define SR_STR_MIXER_CONTROL7_LONG   MIX_STR_BASE + 61
#define SR_STR_MIXER_CONTROL8_LONG   MIX_STR_BASE + 62
#define SR_STR_MIXER_CONTROL9_LONG   MIX_STR_BASE + 63
#define SR_STR_MIXER_CONTROL10_LONG  MIX_STR_BASE + 64
#define SR_STR_MIXER_CONTROL11_LONG  MIX_STR_BASE + 65
#define SR_STR_MIXER_CONTROL12_LONG  MIX_STR_BASE + 66
#define SR_STR_MIXER_CONTROL13_LONG  MIX_STR_BASE + 67
#define SR_STR_MIXER_CONTROL14_LONG  MIX_STR_BASE + 68
#define SR_STR_MIXER_CONTROL15_LONG  MIX_STR_BASE + 69
#define SR_STR_MIXER_CONTROL16_LONG  MIX_STR_BASE + 70
#define SR_STR_MIXER_CONTROL17_LONG  MIX_STR_BASE + 71
#define SR_STR_MIXER_CONTROL18_LONG  MIX_STR_BASE + 72

#define SR_STR_MIXER_CONTROL0_SHORT  MIX_STR_BASE + 73
#define SR_STR_MIXER_CONTROL1_SHORT  MIX_STR_BASE + 74
#define SR_STR_MIXER_CONTROL2_SHORT  MIX_STR_BASE + 75
#define SR_STR_MIXER_CONTROL3_SHORT  MIX_STR_BASE + 76
#define SR_STR_MIXER_CONTROL4_SHORT  MIX_STR_BASE + 77
#define SR_STR_MIXER_CONTROL5_SHORT  MIX_STR_BASE + 78
#define SR_STR_MIXER_CONTROL6_SHORT  MIX_STR_BASE + 79
#define SR_STR_MIXER_CONTROL7_SHORT  MIX_STR_BASE + 80
#define SR_STR_MIXER_CONTROL8_SHORT  MIX_STR_BASE + 81
#define SR_STR_MIXER_CONTROL9_SHORT  MIX_STR_BASE + 82
#define SR_STR_MIXER_CONTROL10_SHORT MIX_STR_BASE + 83
#define SR_STR_MIXER_CONTROL11_SHORT MIX_STR_BASE + 84
#define SR_STR_MIXER_CONTROL12_SHORT MIX_STR_BASE + 85
#define SR_STR_MIXER_CONTROL13_SHORT MIX_STR_BASE + 86
#define SR_STR_MIXER_CONTROL14_SHORT MIX_STR_BASE + 87
#define SR_STR_MIXER_CONTROL15_SHORT MIX_STR_BASE + 88
#define SR_STR_MIXER_CONTROL16_SHORT MIX_STR_BASE + 89
#define SR_STR_MIXER_CONTROL17_SHORT MIX_STR_BASE + 90
#define SR_STR_MIXER_CONTROL18_SHORT MIX_STR_BASE + 91

LRESULT FAR PASCAL DrvLoadVolumeFromReg
(
   PHARDWAREINSTANCE  phwi
) ;

LRESULT FAR PASCAL DrvSaveVolumeToReg
(
    PHARDWAREINSTANCE   phwi
) ;

//---------------------------------------------------------------------------
//  End of File: driver.h
//---------------------------------------------------------------------------

